<template>
    <div>
        <v-app-bar flat max-height="64px" height="64px" color="primary" dark>
            <v-container class="d-flex justify-space-between align-center">
                <router-link :to="{name: 'Home'}">
                    <v-img
                        alt="Vetvite logo"
                        class="shrink hidden-xs-only"
                        contain
                        min-width="140"
                        src="@/assets/images/logo/logo-text.png"
                        width="100"
                    />
                    <v-img
                        alt="Vetvite logo"
                        class="mx-auto hidden-sm-and-up"
                        contain
                        min-width="20"
                        src="@/assets/images/logo/logo-white.png"
                        width="50"
                    />
                </router-link>
                <div class="hidden-sm-and-down">
                    <v-menu v-if="isLoggedIn" :close-on-content-click="true" :nudge-width="70" offset-y>
                        <template v-slot:activator="{ on, attrs }">
                            <v-btn text class="ml-2" v-bind="attrs" v-on="on">
                                {{user.firstName}} {{user.lastName}} <v-icon>mdi-chevron-down</v-icon>
                            </v-btn>
                        </template>

                        <v-card>
                            <AccountMenuList />
                        </v-card>
                    </v-menu>
                    <router-link class="text-decoration-none" :to="{name: 'Login'}" v-else>
                        <v-btn text>
                            Se connecter
                        </v-btn>
                    </router-link>
                </div>
                <div class="hidden-md-and-up"> <!--isLoggedIn-->
                    <v-app-bar-nav-icon v-if="isLoggedIn" class="float-right" @click.stop="accountDrawer = !accountDrawer">
                        <v-icon>mdi-account</v-icon>
                    </v-app-bar-nav-icon>
                    <router-link v-else class="float-right" :to="{name: 'Login'}">
                        <v-btn icon>
                            <v-icon>mdi-login</v-icon>
                        </v-btn>
                    </router-link>
                </div>
            </v-container>
        </v-app-bar>

        <v-navigation-drawer v-model="accountDrawer" absolute temporary right>
            <v-list-item>
                <v-list-item-content>
                    <v-list-item-title class="title">
                        {{user.firstName}} {{user.lastName}}
                    </v-list-item-title>
                </v-list-item-content>
            </v-list-item>
            <AccountMenuList />
            <template v-slot:append>
                <div class="pa-2">
                    <v-btn block @click="handleLogout" color="secondary" small>
                        Déconnexion
                    </v-btn>
                </div>
            </template>
        </v-navigation-drawer>
    </div>
</template>

<script>
import AccountMenuList from "@/components/Header/AccountMenuList";
import {mapGetters} from 'vuex';

export default {
    computed: {
        ...mapGetters(['isLoggedIn', 'user'])
    },
    data: () => ({
        accountDrawer: false,
    }),
    components: {
        AccountMenuList
    },
    provide: function () {
        return {
            logout: this.handleLogout
        }
    },
    methods: {
        handleLogout: function () {
            this.accountDrawer = false;
            this.$store.dispatch('logout')
                .then(() => {
                    this.$router.push({ name: 'Home' }, undefined, () => { location.href = this.$route.hash })
                })
        }
    },
}
</script>
